#ifndef EWL_CONTEXT_MENU_H
#define EWL_CONTEXT_MENU_H

typedef struct Ewl_Context_Menu Ewl_Context_Menu;

#define EWL_CONTEXT_MENU(cm) ((Ewl_Context_Menu *) (cm))

struct Ewl_Context_Menu
{
    Ewl_Floater     floater; /**< Inherit from Ewl_Floater */
    Ewl_Widget    * menu;    /**< The menu*/
    Ewl_Widget    * parent;
};

#ifdef __cplusplus
extern "C" {
#endif
    
Ewl_Widget     * ewl_context_menu_new(void);
int              ewl_context_menu_init(Ewl_Context_Menu * menu);
void             ewl_context_menu_active_area_add(Ewl_Context_Menu * m, Ewl_Widget * p);
void             ewl_context_menu_active_area_del(Ewl_Context_Menu * m, Ewl_Widget * p);

/*
 * internally used callbacks, override at your risk
 */
void ewl_context_menu_mouse_down_cb(Ewl_Widget * w, void * ev_data, void * user_data);

#ifdef __cplusplus
}
#endif

#endif
