#include"Eli_App.h"

static void         _item_select_cb (Ewl_Widget * w, void * ev_data, void * user_data);
static void         _add_item       (const char * text, Ewl_Widget * container, void * data);
static void         _new_cb         (Ewl_Widget * w, void * ev_data, void * user_data);
static Ewl_Widget * _new_menu       (Eli_App * eap);

Ewl_Widget * eli_conmenu_new(Eli_App * eap)
{

    Ewl_Widget * menu;
    Ewl_Widget * w;

    menu = ewl_context_menu_new();
   
    ewl_widget_show(menu);

    w = _new_menu(eap);
    ewl_container_child_append(EWL_CONTAINER(menu), w);
    _add_item(sgettext(N_("CONTEXT|Undo")), menu, eap);
    _add_item(sgettext(N_("CONTEXT|Highscore")), menu, eap);
    _add_item(sgettext(N_("CONTEXT|Preferences")), menu, eap);
    _add_item(sgettext(N_("CONTEXT|About")), menu, eap);
/*
    w = ewl_button_new();
    ewl_button_label_set(EWL_BUTTON(w), "Button");
    ewl_container_child_append(EWL_CONTAINER(eap->embed.w), w);
    ewl_widget_show(w);
   */ 
    return EWL_WIDGET(menu);
}

static void _add_item(const char * text, Ewl_Widget * container, void * data)
{
    Ewl_Widget * w;

    w = ewl_menu_item_new();
    ewl_button_label_set(EWL_BUTTON(w), text);
    ewl_container_child_append(EWL_CONTAINER(container), w);
    ewl_callback_append(w, EWL_CALLBACK_CLICKED, _item_select_cb, data);
    ewl_widget_show(w);
}

static void _item_select_cb(Ewl_Widget * w, void * ev_data, void * user_data)
{
    const char * text;
    Eli_App * eap;

    eap = (Eli_App *) user_data;

    text = ewl_button_label_get(EWL_BUTTON(w));
    if (!strcmp(text, sgettext(N_("CONTEXT|Undo")))) {
        if (eap->elitaire)
            elitaire_object_undo(eap->elitaire);
    }
    else if (!strcmp(text, sgettext(N_("CONTEXT|Highscore"))))
        win_highscore_open("");
    else if (!strcmp(text, sgettext(N_("CONTEXT|Preferences"))))
        win_config_window_open();
    else if (!strcmp(text, sgettext(N_("CONTEXT|About"))))
        win_about_open();
}

static Ewl_Widget * _new_menu(Eli_App * eap)
{
    const char ** games;
    Ewl_Widget * menu;

    games = elitaire_available_games_get();

    menu = ewl_menu_new();
    ewl_button_label_set(EWL_BUTTON(menu), sgettext(N_("CONTEXT|New")));

    for (int i = 0; games[i][0]; i++) {
        Ewl_Widget * w;

        w = ewl_menu_item_new();
        ewl_button_label_set(EWL_BUTTON(w), games[i]);
        ewl_container_child_append(EWL_CONTAINER(menu), w);
        ewl_callback_append(w, EWL_CALLBACK_CLICKED, _new_cb, eap);
        ewl_widget_show(w);
    }
    ewl_widget_show(menu);
    return menu;
}

static void _new_cb(Ewl_Widget * w, void * ev_data, void * user_data)
{
    const char * text;
    Eli_App * eap;

    eap = (Eli_App *) user_data;

    text = ewl_button_label_get(EWL_BUTTON(w));

    eli_app_game_new(eap, text);
}
